#sendSMS
#Using tip-top-sms.ru SMS service (standart)
#By Kissa2k

package sendSMS;

use strict;
use IO::Socket;
use Plugins;
use Commands;
use Globals;
use Utils;
use Log qw(message error warning);

Plugins::register('sendSMS', 'Send SMS messages.', \&Unload, \&Unload);

my $hook = Commands::register(
    ['sms','Send SMS messages.',\&sms]
);

sub Unload {
	Commands::unregister($hook);
}

sub trim {
    my($string)=@_;
    for ($string) {
        s/^\s+//;
        s/\s+$//;
        }
    return $string;
}

sub sms {
	my (undef, $args) = @_;
	my @args = split(/ /, $args);
	
	my $sent = 0;
	my $message;
	my $sock;
	
	if($args[0]){
	
		for(my $i=0; $i <= @args; $i++){
			$message .= $args[$i]." ";
		}
		$message = trim($message);
		$message = urlencode($message);
		
		if(length($message) >= 140){
			message("[sendSMS] Your message is too large.\n", "info");
			return;
		}
		
		# ..
		while(!$sock){
			$sock = new IO::Socket::INET(
				PeerAddr => 'tip-top-sms.ru',
				PeerPort => '80',
				Proto => 'tcp');
		}
		
		print $sock "GET /sendsms.php?username=".$config{'sendSMS_0_username'}."&passwd=".$config{'sendSMS_0_password'}."&number=".$config{'sendSMS_0_number'}."&lblMax=160&text_sms=".$message." HTTP/1.1\r\n";
		print $sock "Host: tip-top-sms.ru\r\n";
		print $sock "User-Agent: $Settings::NAME $Settings::VERSION($Settings::NAME)\r\n";
		print $sock "Accept: */*\r\n";
		print $sock "Accept-Language: en-us,en\r\n";
		print $sock "Connection: close\r\n";
		print $sock "Referer: http://tip-top-sms.ru/\r\n";
		print $sock "\r\n";

		while(<$sock>){
			$sent = 1 if($_ =~ m/-  /); 
		}
		
		if($sent){
			message("[sendSMS] Your SMS has been successfully sent.\n");
		}else{
			error("[sendSMS] Failed to send SMS.\n");
		}
		
		close($sock);
	}else{
		error("[sendSMS] Syntax Error in function 'sms'\nUsage: sms < message >\nWhere < message > is your SMS message.\n");	
	}
}

return 1;
